

   MEMBER('Maillist.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('MAILL002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('MAILL001.INC'),ONCE        !Req'd for module callout resolution
                     END


Maillist_BrowseMailers PROCEDURE                      !Generated from procedure template - Window

CurrentTab           STRING(80)
PeopleText           STRING(40)
PeopleCount          USHORT
LocalRequest         LONG
FilesOpened          BYTE
MailerText           STRING(30)
BRW1::View:Browse    VIEW(Mailers)
                       PROJECT(MAI:Description)
                       PROJECT(MAI:MailerNotes)
                       PROJECT(MAI:MailerNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
MAI:Description        LIKE(MAI:Description)          !List box control field - type derived from field
MAI:MailerNotes        STRING(SIZE(MAI:MailerNotes))  !Browse hot field - STRING defined to hold MEMO's contents
MAI:MailerNumber       LIKE(MAI:MailerNumber)         !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Mailer Listing'),AT(,,348,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~MailerListing'),SYSTEM,GRAY,DOUBLE,MDI
                       LIST,AT(15,31,155,113),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Mailing List Records'),TIP('Mailing List '),FORMAT('80L|M@s20@'),FROM(Queue:Browse:1)
                       BUTTON('Close'),AT(13,175,69,22),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Save and exit the window'),TIP('Exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(264,175,69,22),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Click to display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,1,343,170),USE(?Panel4)
                       PANEL,AT(9,6,166,160),USE(?Panel2)
                       STRING(@s35),AT(187,16,145,12),USE(PeopleText),TRN,CENTER,FONT('Arial',8,,FONT:bold)
                       STRING(@n6),AT(239,30),USE(PeopleCount),CENTER,FONT('Arial',12,,FONT:bold)
                       PANEL,AT(177,6,165,160),USE(?Panel3)
                       STRING('Type a letter to locate a mailing list'),AT(17,9),USE(?String2),FONT(,,,FONT:bold)
                       PANEL,AT(181,10,157,38),USE(?Panel5),BEVEL(-1,-1)
                       STRING(@s30),AT(17,150,149,10),USE(MailerText),TRN,CENTER,FONT('Arial',10,,FONT:bold)
                       PANEL,AT(3,172,342,27),USE(?Panel7)
                       STRING(@s20),AT(17,20),USE(MAI:Description)
                       BUTTON('&Insert'),AT(153,4,34,12),USE(?Insert:2),HIDE,LEFT,MSG('Add a new mailing list'),TIP('Add a new mailing list')
                       BUTTON('&Change'),AT(153,12,35,12),USE(?Change:2),HIDE,LEFT,MSG('Change the highlighted mailing list'),TIP('Change the highlighted mailing list'),DEFAULT
                       BUTTON('&Delete'),AT(153,20,33,12),USE(?Delete:2),HIDE,LEFT,MSG('Delete the highlighted mailing list'),TIP('Delete the highlighted mailing list')
                       STRING('Mailing Notes:'),AT(185,49),USE(?String1),FONT(,,,FONT:bold)
                       TEXT,AT(181,60,156,85),USE(MAI:MailerNotes),SKIP,DISABLE,VSCROLL,MSG('Special Notes about the Mailing'),TIP('Mailing Notes')
                       PANEL,AT(13,148,157,15),USE(?Panel6),BEVEL(-1,-1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeNewSelection       PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_BrowseMailers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MailPeople.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Mailers,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,MAI:DescriptionKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?MAI:Description,MAI:Description,1,BRW1)
  BRW1.AddField(MAI:Description,BRW1.Q.MAI:Description)
  BRW1.AddField(MAI:MailerNotes,BRW1.Q.MAI:MailerNotes)
  BRW1.AddField(MAI:MailerNumber,BRW1.Q.MAI:MailerNumber)
  INIMgr.Fetch('Maillist_BrowseMailers',QuickWindow)
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_BrowseMailers',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  ! Display the number of mailing lists
  MailerText = 'Number of mailing lists: '&RECORDS(MAI:MailerNumberKey)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    UpdateMailers
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeNewSelection PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeNewSelection()
    CASE FIELD()
    OF ?Browse:1
      !  This will calculate the number of people in a mailing list
      BRW1.UpdateViewRecord                                           !Make sure we have the right record in memory
      CLEAR(MAP:RECORD)                                               !Clear bogus data for record
      CLEAR(PeopleCount)                                              !  and local variable
      MAP:MailerNumber = MAI:MailerNumber                             !Prime key value with selected mailing record
      SET(MAP:MailerNumberKey,MAP:MailerNumberKey)                    !Set to first value in MAP file
      LOOP UNTIL Access:MailPeople.Next()                             ! Get first record
        IF MAP:MailerNumber <> MAI:MailerNumber THEN BREAK.           !If it doesn't belong to this mailing, break
        PeopleCount += 1                                              !Increment the counter
      END
      PeopleText = 'People in '&CLIP(BRW1.Q.MAI:Description)&' List:'  !Display the count on screen
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END

SelectKeyWords PROCEDURE                              !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(KeyWords)
                       PROJECT(KEY:KeyWordDescription)
                       PROJECT(KEY:KeyWordNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
KEY:KeyWordDescription LIKE(KEY:KeyWordDescription)   !List box control field - type derived from field
KEY:KeyWordNumber      LIKE(KEY:KeyWordNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a Keyword'),AT(,,158,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~SelectaKeyword'),SYSTEM,GRAY,MDI
                       LIST,AT(9,26,142,113),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('80L|M@s30@'),FROM(Queue:Browse:1)
                       BUTTON(' {17}&Select'),AT(8,143,144,23),USE(?Select:2),RIGHT,FONT('Arial',12,,FONT:bold),MSG('Choose the highlighted keyword'),TIP('Select highlighted keyword'),ICON('POINT01.ICO')
                       BUTTON('Close'),AT(9,174,65,20),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit the window'),TIP('Exit the window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(87,174,65,20),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Click to display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,1,153,168),USE(?Panel1)
                       STRING('Type a letter to locate a keyword'),AT(8,3),USE(?String1),FONT('Arial',10,,FONT:bold)
                       STRING(@s30),AT(8,15),USE(KEY:KeyWordDescription),FONT('Arial',8,,FONT:regular)
                       PANEL,AT(3,171,153,26),USE(?Panel2)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectKeyWords')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:KeyWords.Open
  Access:PeopleKeys.UseFile
  Access:People.UseFile
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:KeyWords,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,KEY:KeyWordDescriptionKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?KEY:KeyWordDescription,KEY:KeyWordDescription,1,BRW1)
  BRW1.AddField(KEY:KeyWordDescription,BRW1.Q.KEY:KeyWordDescription)
  BRW1.AddField(KEY:KeyWordNumber,BRW1.Q.KEY:KeyWordNumber)
  INIMgr.Fetch('SelectKeyWords',QuickWindow)
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:KeyWords.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectKeyWords',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Select:2
      !Add selected record to the file
      BRW1.UpdateBuffer  !Make sure you have the correct record
      PKW:KeyWordNumber = KEY:KeyWordNumber                    !Assign variables for file
      PKW:KeyWordDescription = KEY:KeyWordDescription
      PKW:IDNumber = PEO:IDNumber
      IF Access:PeopleKeys.TryInsert() = Level:Notify          !Check file for duplicate entry
        MESSAGE('Selected word is already a keyword for '&CLIP(PEO:FirstName)&' '&PEO:LastName)
        SELECT(?Select:2)                                     !If duplicate, go back to select list
        CYCLE
      END
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1

UpdatePeople PROCEDURE                                !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
bufnum               USHORT
BRW3::View:Browse    VIEW(PeopleKeys)
                       PROJECT(PKW:KeyWordDescription)
                       PROJECT(PKW:IDNumber)
                       PROJECT(PKW:KeyWordNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List:1
PKW:KeyWordDescription LIKE(PKW:KeyWordDescription)   !List box control field - type derived from field
PKW:IDNumber           LIKE(PKW:IDNumber)             !Primary key field - type derived from field
PKW:KeyWordNumber      LIKE(PKW:KeyWordNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW2::View:Browse    VIEW(MailPeople)
                       PROJECT(MAP:Status)
                       PROJECT(MAP:IDNumber)
                       PROJECT(MAP:MailerNumber)
                       JOIN(MAI:MailerNumberKey,MAP:MailerNumber)
                         PROJECT(MAI:Description)
                         PROJECT(MAI:MailerNumber)
                       END
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?List
MAI:Description        LIKE(MAI:Description)          !List box control field - type derived from field
MAI:Description_NormalFG LONG                         !Normal forground color
MAI:Description_NormalBG LONG                         !Normal background color
MAI:Description_SelectedFG LONG                       !Selected forground color
MAI:Description_SelectedBG LONG                       !Selected background color
MAP:Status             LIKE(MAP:Status)               !List box control field - type derived from field
MAP:Status_NormalFG    LONG                           !Normal forground color
MAP:Status_NormalBG    LONG                           !Normal background color
MAP:Status_SelectedFG  LONG                           !Selected forground color
MAP:Status_SelectedBG  LONG                           !Selected background color
MAP:IDNumber           LIKE(MAP:IDNumber)             !Primary key field - type derived from field
MAP:MailerNumber       LIKE(MAP:MailerNumber)         !Primary key field - type derived from field
MAI:MailerNumber       LIKE(MAI:MailerNumber)         !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::PEO:Record  LIKE(PEO:RECORD),STATIC
QuickWindow          WINDOW('Personal Profile Information'),AT(,,359,203),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('MAIL10.ICO'),HLP('~PeopleForm'),SYSTEM,GRAY,MDI
                       SHEET,AT(7,4,343,171),USE(?CurrentTab)
                         TAB('Personal Profile'),USE(?Profile)
                           PANEL,AT(15,23,328,58),USE(?Panel1)
                           PROMPT('Name:'),AT(23,26),USE(?PEO:Salutation:Prompt)
                           LIST,AT(70,26,29,10),USE(PEO:Salutation),LEFT,MSG('Salutation'),DROP(5),FROM('Mr.|Mrs.|Ms.|Miss|Dr.|Hon.')
                           ENTRY(@s20),AT(101,26,84,10),USE(PEO:FirstName),LEFT,MSG('Person''s First Name'),CAP
                           ENTRY(@s1),AT(187,26,13,10),USE(PEO:MiddleInitial),MSG('Person''s Middle Initial (optiional)'),CAP
                           ENTRY(@s25),AT(202,26,104,10),USE(PEO:LastName),LEFT,MSG('Last Name'),REQ,CAP
                           LIST,AT(308,26,28,10),USE(PEO:NameSuffix),LEFT,MSG('Person''s Name Suffix (optional)'),DROP(5),FROM(' |Jr.|Sr.|II|III|Esq.')
                           PROMPT('Street '),AT(23,42),USE(?PEO:Address1:Prompt)
                           ENTRY(@s35),AT(70,39,144,10),USE(PEO:Address1),LEFT,MSG('Person''s Mailing Address Line 1'),REQ,CAP
                           PROMPT('Address:'),AT(23,50),USE(?PEO:Address2:Prompt)
                           ENTRY(@s35),AT(70,52,144,10),USE(PEO:Address2),LEFT,MSG('Person''s Mailing Address Line 2 (optional)'),CAP
                           ENTRY(@s25),AT(70,65,104,10),USE(PEO:City),LEFT,MSG('Person''s Mailing City'),REQ,CAP
                           ENTRY(@s2),AT(176,65,17,10),USE(PEO:State),LEFT,MSG('Person''s Mailing State'),UPR
                           ENTRY(@s10),AT(196,65,44,10),USE(PEO:ZipCode),MSG('Person''s Mailing Zipcode')
                           PROMPT('Birthdate:'),AT(24,89),USE(?PEO:Birthdate:Prompt)
                           ENTRY(@D01),AT(70,89,51,10),USE(PEO:Birthdate),IMM,MSG('Person''s Birthdate - mm/dd/yyyy'),INS
                           PANEL,AT(15,107,150,64),USE(?Panel3)
                           PANEL,AT(166,107,177,64),USE(?Panel4)
                           OPTION('Sex'),AT(169,83,101,17),USE(PEO:Sex),BOXED,MSG('Person''s Sex (M or F)')
                             RADIO('Female'),AT(191,89),USE(?PEO:Sex:Radio1),MSG('Sex: Female')
                             RADIO('Male'),AT(234,89),USE(?PEO:Sex:Radio2),MSG('Sex: Male')
                           END
                           PANEL,AT(15,81,328,25),USE(?Panel2)
                           PROMPT('Keyword:'),AT(24,108),USE(?Pro:Keyword)
                           LIST,AT(69,115,88,50),USE(?List:1),IMM,VSCROLL,MSG('Listing of Keywords'),TIP('Keywords'),FORMAT('120L@s30@'),FROM(Queue:Browse)
                           BUTTON,AT(23,119,39,26),USE(?Insert),MSG('Add a keyword'),TIP('Add a keyword'),KEY(F2Key),ICON('CRDFLE12.ICO'),FLAT
                           BUTTON('D'),AT(23,143,39,22),USE(?Delete),MSG('Delete a keyword'),TIP('Delete selected keyword'),ICON('TRASH01.ICO'),FLAT
                           PROMPT('Notes:'),AT(172,109,21,12),USE(?PEO:Notes:Prompt)
                           TEXT,AT(198,115,140,50),USE(PEO:Notes),VSCROLL,MSG('Special Comments about Person'),TIP('Notes')
                         END
                         TAB('Mailing Lists'),USE(?MailingListTab)
                           PANEL,AT(21,23,311,146),USE(?Panel5)
                           PANEL,AT(127,32,170,128),USE(?Panel7)
                           LIST,AT(131,35,163,121),USE(?List),IMM,VSCROLL,MSG('Browsing Mail List Records'),TIP('Listing of Mailers'),FORMAT('80L|*~ Description~@s20@32L*~ Status~@s8@'),FROM(Queue:Browse:1)
                           BUTTON,AT(56,46,46,24),USE(?NewInsert),MSG('Add a Mailing to List'),TIP('Add a Mailing to the List'),ICON('CRDFLE12.ICO'),FLAT
                           PANEL,AT(50,32,57,128),USE(?Panel6)
                           BUTTON,AT(299,39,42,24),USE(?Insert:2),SKIP,HIDE,LEFT,ICON('CRDFLE12.ICO')
                           BUTTON,AT(56,80,46,24),USE(?Change),MSG('Modify the highlighted item'),TIP('Modify the highlighted mailing'),ICON('ERASE02.ICO'),FLAT
                           BUTTON,AT(56,117,46,24),USE(?Delete:2),MSG('Delete the highlighted mailing'),TIP('Delete the selected mailing '),ICON('TRASH01.ICO'),FLAT
                         END
                       END
                       BUTTON('OK'),AT(65,177,74,22),USE(?OK),LEFT,FONT('Arial',12,COLOR:Green,FONT:bold),MSG('Save and Exit Window'),TIP('Save & Exit'),ICON(ICON:Tick),DEFAULT
                       BUTTON('Cancel'),AT(149,177,74,22),USE(?Cancel),LEFT,FONT('Arial',12,COLOR:Red,FONT:bold),MSG('Exit Window without changes'),TIP('Exit without saving'),ICON(ICON:Cross)
                       BUTTON('Help'),AT(233,177,74,22),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display On-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Open                   PROCEDURE(),DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW3                 CLASS(BrowseClass)               !Browse using ?List:1
Q                      &Queue:Browse                  !Reference to browse queue
                     END

BRW3::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW2                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW2::Sort0:Locator  StepLocatorClass                 !Default Locator
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Personal Proflie'
  OF ChangeRecord
    ActionMessage = 'Updating a Personal Profile'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdatePeople')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(PEO:Record,History::PEO:Record)
  SELF.AddHistoryField(?PEO:Salutation,2)
  SELF.AddHistoryField(?PEO:FirstName,3)
  SELF.AddHistoryField(?PEO:MiddleInitial,4)
  SELF.AddHistoryField(?PEO:LastName,5)
  SELF.AddHistoryField(?PEO:NameSuffix,6)
  SELF.AddHistoryField(?PEO:Address1,7)
  SELF.AddHistoryField(?PEO:Address2,8)
  SELF.AddHistoryField(?PEO:City,9)
  SELF.AddHistoryField(?PEO:State,10)
  SELF.AddHistoryField(?PEO:ZipCode,11)
  SELF.AddHistoryField(?PEO:Birthdate,12)
  SELF.AddHistoryField(?PEO:Sex,13)
  SELF.AddHistoryField(?PEO:Notes,14)
  SELF.AddUpdateFile(Access:People)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:MailPeople.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:People
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW3.Init(?List:1,Queue:Browse.ViewPosition,BRW3::View:Browse,Queue:Browse,Relate:PeopleKeys,SELF)
  BRW2.Init(?List,Queue:Browse:1.ViewPosition,BRW2::View:Browse,Queue:Browse:1,Relate:MailPeople,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW3.Q &= Queue:Browse
  BRW3.AddSortOrder(,PKW:IDKeyWordKey)
  BRW3.AddRange(PKW:IDNumber,Relate:PeopleKeys,Relate:People)
  BRW3.AddLocator(BRW3::Sort0:Locator)
  BRW3::Sort0:Locator.Init(,PKW:KeyWordNumber,1,BRW3)
  BRW3.AddField(PKW:KeyWordDescription,BRW3.Q.PKW:KeyWordDescription)
  BRW3.AddField(PKW:IDNumber,BRW3.Q.PKW:IDNumber)
  BRW3.AddField(PKW:KeyWordNumber,BRW3.Q.PKW:KeyWordNumber)
  BRW2.Q &= Queue:Browse:1
  BRW2.AddSortOrder(,MAP:CustomerNumberKey)
  BRW2.AddRange(MAP:IDNumber,Relate:MailPeople,Relate:People)
  BRW2.AddLocator(BRW2::Sort0:Locator)
  BRW2::Sort0:Locator.Init(,MAP:IDNumber,1,BRW2)
  BRW2.AddField(MAI:Description,BRW2.Q.MAI:Description)
  BRW2.AddField(MAP:Status,BRW2.Q.MAP:Status)
  BRW2.AddField(MAP:IDNumber,BRW2.Q.MAP:IDNumber)
  BRW2.AddField(MAP:MailerNumber,BRW2.Q.MAP:MailerNumber)
  BRW2.AddField(MAI:MailerNumber,BRW2.Q.MAI:MailerNumber)
  INIMgr.Fetch('UpdatePeople',QuickWindow)
  BRW2.AskProcedure = 2
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW3.AddToolbarTarget(Toolbar)
  BRW3.ToolbarItem.HelpButton = ?Help
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdatePeople',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Open PROCEDURE

  CODE
  PARENT.Open
  !Turn the highlight bar on the keyword list box off except when has focus
  ?List:1{PROP:NOBAR} = TRUE


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  STA:CODE = PEO:State                                ! Assign linking field value
  Access:STATES.Fetch(STA:STATEKEY)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectState
      UpdateMailPeople
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Insert
      !Save the parent to the buffer before calling the keyword browse
        bufnum = Access:PEOPLE.SaveBuffer()
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?PEO:State
      IF QuickWindow{Prop:AcceptAll} = False
        STA:CODE = PEO:State
        IF Access:STATES.TryFetch(STA:STATEKEY)
          IF SELF.Run(1,SelectRecord) = RequestCompleted
            PEO:State = STA:CODE
          ELSE
            SELECT(?PEO:State)
            CYCLE
          END
        END
      END
      ThisWindow.Reset(0)
      IF Access:People.TryValidateField(10)
        SELECT(?PEO:State)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?PEO:State
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?PEO:State{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?Insert
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectKeyWords
      ThisWindow.Reset
      !Update the list box with the added record
      BRW3.ResetSort(1)
      !Restore the parent file after the read to the keyword file
        Access:PEOPLE.RestoreBuffer(bufnum)
    OF ?Delete
      ThisWindow.Update
      !Message to verify deletion
      Relate:PeopleKeys.Delete()                                               !Check for error
      BRW3.ResetSort(1)                                                        !Redisplay list box
    OF ?NewInsert
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectMailers
      ThisWindow.Reset
      !Update list box with added record
      BRW2.ResetSort(1)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete:2
  END


BRW2.SetQueueRecord PROCEDURE

  CODE
  PARENT.SetQueueRecord
  IF (MAP:Status = 'Active')
    SELF.Q.MAI:Description_NormalFG = 32768
    SELF.Q.MAI:Description_NormalBG = -1
    SELF.Q.MAI:Description_SelectedFG = 65280
    SELF.Q.MAI:Description_SelectedBG = 8388608
  ELSIF (MAP:Status = 'Inactive')
    SELF.Q.MAI:Description_NormalFG = 128
    SELF.Q.MAI:Description_NormalBG = -1
    SELF.Q.MAI:Description_SelectedFG = 12632256
    SELF.Q.MAI:Description_SelectedBG = 8388608
  ELSE
    SELF.Q.MAI:Description_NormalFG = -1
    SELF.Q.MAI:Description_NormalBG = -1
    SELF.Q.MAI:Description_SelectedFG = -1
    SELF.Q.MAI:Description_SelectedBG = -1
  END
  IF (MAP:Status = 'Active')
    SELF.Q.MAP:Status_NormalFG = 32768
    SELF.Q.MAP:Status_NormalBG = -1
    SELF.Q.MAP:Status_SelectedFG = 65280
    SELF.Q.MAP:Status_SelectedBG = 8388608
  ELSIF (MAP:Status = 'Inactive')
    SELF.Q.MAP:Status_NormalFG = 128
    SELF.Q.MAP:Status_NormalBG = -1
    SELF.Q.MAP:Status_SelectedFG = 12632256
    SELF.Q.MAP:Status_SelectedBG = 8388608
  ELSE
    SELF.Q.MAP:Status_NormalFG = -1
    SELF.Q.MAP:Status_NormalBG = -1
    SELF.Q.MAP:Status_SelectedFG = -1
    SELF.Q.MAP:Status_SelectedBG = -1
  END

SelectMailers PROCEDURE                               !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(Mailers)
                       PROJECT(MAI:Description)
                       PROJECT(MAI:MailerNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
MAI:Description        LIKE(MAI:Description)          !List box control field - type derived from field
MAI:MailerNumber       LIKE(MAI:MailerNumber)         !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a Mailing List'),AT(,,158,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~SelectaMailingList'),SYSTEM,GRAY,MDI
                       LIST,AT(8,28,142,106),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Maili List Records'),TIP('Listing of Mailers'),FORMAT('80L|M@s20@'),FROM(Queue:Browse:1)
                       BUTTON(' {16}&Select'),AT(7,137,143,25),USE(?Select:2),RIGHT,FONT('Arial',12,,FONT:bold),MSG('Select a Mailing List'),TIP('Select a mailing list'),ICON('POINT01.ICO')
                       PANEL,AT(3,2,152,165),USE(?Panel1)
                       STRING('Type a letter to locate a maliling'),AT(9,4),USE(?String1),FONT('Arial',10,,FONT:bold)
                       STRING(@s20),AT(10,15),USE(MAI:Description),FONT('Arial',10,,FONT:regular)
                       PANEL,AT(3,170,151,28),USE(?Panel2)
                       BUTTON('Close'),AT(9,174,65,20),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit the window'),TIP('Exit the window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(86,174,65,20),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectMailers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MailPeople.Open
  Access:People.UseFile
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Mailers,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,MAI:DescriptionKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?MAI:Description,MAI:Description,1,BRW1)
  BRW1.AddField(MAI:Description,BRW1.Q.MAI:Description)
  BRW1.AddField(MAI:MailerNumber,BRW1.Q.MAI:MailerNumber)
  INIMgr.Fetch('SelectMailers',QuickWindow)
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectMailers',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Select:2
      !Add the selected record to the file
      ThisWindow.Update  !Make sure to get the right record
      MAP:IDNumber = PEO:IDNumber                           !Assign file variables
      MAP:MailerNumber=MAI:MailerNumber
      MAP:Status = 'Active'
      IF Access:MailPeople.TryInsert() = Level:Notify       !Check for duplicate value
        MESSAGE(CLIP(MAI:Description)&' is already a mailing list for '& CLIP(PEO:FirstName)&' '&PEO:LastName)
        SELECT(?Select:2)                                   !If dup, go back to list
        CYCLE
      END
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1

SelectState PROCEDURE                                 !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(STATES)
                       PROJECT(STA:CODE)
                       PROJECT(STA:NAME)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
STA:CODE               LIKE(STA:CODE)                 !List box control field - type derived from field
STA:NAME               LIKE(STA:NAME)                 !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a State'),AT(,,158,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~SelectaState'),SYSTEM,GRAY,RESIZE,MDI
                       LIST,AT(8,26,140,116),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing State Records'),TIP('Listing of States'),FORMAT('27C(2)|M~CODE~L@s2@80L(2)|M~NAME~@s25@'),FROM(Queue:Browse:1)
                       BUTTON(' {16}&Select'),AT(8,146,140,22),USE(?Select:2),RIGHT,FONT('Arial',12,,FONT:bold),MSG('Choose highlighted state'),TIP('Select highlighted state'),ICON('POINT01.ICO')
                       BUTTON('Close'),AT(10,176,63,19),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit the window'),TIP('Exit the window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(89,176,63,19),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,2,151,169),USE(?Panel1)
                       STRING('Type a letter to locate a state'),AT(17,4),USE(?String1),FONT('Arial',10,,FONT:bold)
                       STRING(@s2),AT(18,15),USE(STA:CODE),FONT('Arial',10,,FONT:regular)
                       PANEL,AT(3,173,152,26),USE(?Panel2)
                       BUTTON('&Insert'),AT(14,38,45,14),USE(?Insert:3),SKIP,DISABLE,HIDE
                       BUTTON('&Change'),AT(15,53,45,14),USE(?Change:3),SKIP,DISABLE,HIDE,DEFAULT
                       BUTTON('&Delete'),AT(15,68,45,14),USE(?Delete:3),SKIP,DISABLE,HIDE
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectState')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:STATES.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:STATES,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,STA:STATEKEY)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?STA:CODE,STA:CODE,1,BRW1)
  BRW1.AddField(STA:CODE,BRW1.Q.STA:CODE)
  BRW1.AddField(STA:NAME,BRW1.Q.STA:NAME)
  INIMgr.Fetch('SelectState',QuickWindow)
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:STATES.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectState',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1

Maillist_BrowsePeople PROCEDURE                       !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LastFirst            STRING(45)
RecordCount          STRING(50)
BRW1::View:Browse    VIEW(People)
                       PROJECT(PEO:City)
                       PROJECT(PEO:State)
                       PROJECT(PEO:IDNumber)
                       PROJECT(PEO:LastName)
                       PROJECT(PEO:FirstName)
                       PROJECT(PEO:MiddleInitial)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
LastFirst              LIKE(LastFirst)                !List box control field - type derived from local data
PEO:City               LIKE(PEO:City)                 !List box control field - type derived from field
PEO:State              LIKE(PEO:State)                !List box control field - type derived from field
PEO:IDNumber           LIKE(PEO:IDNumber)             !Primary key field - type derived from field
PEO:LastName           LIKE(PEO:LastName)             !Browse key field - type derived from field
PEO:FirstName          LIKE(PEO:FirstName)            !Browse key field - type derived from field
PEO:MiddleInitial      LIKE(PEO:MiddleInitial)        !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('People Listing'),AT(,,305,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~PeopleListing'),SYSTEM,GRAY,RESIZE,MDI
                       LIST,AT(8,40,284,108),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing People Records'),TIP('People list'),FORMAT('162L|M~Name~@s45@80L|M~City~@s25@24L|M~State~@s2@'),FROM(Queue:Browse:1)
                       BUTTON('Close'),AT(23,175,73,22),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Close the Window'),TIP('Close the window'),ICON('DOORWAY.ICO')
                       BUTTON('&Print'),AT(115,175,73,22),USE(?Print),LEFT,FONT('Arial',12,,FONT:bold),TIP('Print the People Listing'),ICON('TRFFC10A.ICO')
                       BUTTON('Help'),AT(203,175,73,22),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display On-line Help'),TIP('Click to show on-line help'),ICON(ICON:Help),STD(STD:Help)
                       SHEET,AT(5,2,293,169),USE(?CurrentTab)
                         TAB('Name '),USE(?NameTab),FONT('Arial',9,COLOR:Navy,FONT:bold)
                           STRING('Type a letter to locate a person by their last name'),AT(10,17),USE(?String1),FONT('Arial',8,,FONT:regular)
                           STRING(@s25),AT(11,27),USE(PEO:LastName),FONT('Arial',8,,FONT:regular)
                           PANEL,AT(8,151,285,17),USE(?Panel1),BEVEL(-1,-1)
                         END
                         TAB('State/City  '),USE(?StateCityTab),FONT('Arial',9,COLOR:Maroon,FONT:bold)
                           STRING('Type a letter to locate a person by their state'),AT(10,17),USE(?String3),FONT('Arial',8,,FONT:regular)
                           STRING(@s2),AT(10,27),USE(PEO:State),FONT('Arial',8,,FONT:regular)
                           PANEL,AT(8,151,286,17),USE(?Panel3),BEVEL(-1,-1)
                         END
                       END
                       STRING(@s50),AT(9,154,284,10),USE(RecordCount),TRN,CENTER,FONT('Arial',12,,FONT:bold)
                       PANEL,AT(5,172,293,28),USE(?Panel2)
                       BUTTON('&Insert'),AT(238,2,47,12),USE(?Insert:2),HIDE,LEFT,MSG('Add new person to list'),TIP('Click to add new person')
                       BUTTON('&Change'),AT(238,11,48,12),USE(?Change:2),HIDE,LEFT,MSG('Modify the selected record'),TIP('Click to modify the selected person''s record'),DEFAULT
                       BUTTON('&Delete'),AT(237,19,49,12),USE(?Delete:2),HIDE,LEFT,MSG('Delete the selected record'),TIP('Click to delete the selected person''s record')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeNewSelection       PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  FilterLocatorClass               !Default Locator
BRW1::Sort2:Locator  FilterLocatorClass               !Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_BrowsePeople')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:People.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:People,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1.AddSortOrder(,PEO:StateKey)
  BRW1.AddLocator(BRW1::Sort2:Locator)
  BRW1::Sort2:Locator.Init(?PEO:State,PEO:State,1,BRW1)
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,PEO:LastNameKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?PEO:LastName,PEO:LastName,1,BRW1)
  BIND('LastFirst',LastFirst)
  BRW1.AddField(LastFirst,BRW1.Q.LastFirst)
  BRW1.AddField(PEO:City,BRW1.Q.PEO:City)
  BRW1.AddField(PEO:State,BRW1.Q.PEO:State)
  BRW1.AddField(PEO:IDNumber,BRW1.Q.PEO:IDNumber)
  BRW1.AddField(PEO:LastName,BRW1.Q.PEO:LastName)
  BRW1.AddField(PEO:FirstName,BRW1.Q.PEO:FirstName)
  BRW1.AddField(PEO:MiddleInitial,BRW1.Q.PEO:MiddleInitial)
  Resizer.Init(AppStrategy:Spread)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Maillist_BrowsePeople',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  BRW1.PrintProcedure = 2
  BRW1.PrintControl = ?Print
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:People.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_BrowsePeople',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  !  Display the number of people in the list
  RecordCount = 'Total number of people: '&RECORDS(PEO:CustomerNumberKey)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      UpdatePeople
      Maillist_ReportPeopleAlpha
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeNewSelection PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?CurrentTab
      ! Set order of fields in the list box
      CASE CHOICE(?CurrentTab)                                     !Check which tab is selected
      OF 1                                                         !Name tab
        ?BROWSE:1{PROP:Format} =  '180L|M~Name~@s45@#1#' & |       !  Name
                                  '80L|M~City~@s25@#2#'    & |     !  City
                                  '24L|M~State~@s2@#3#'            !  State
      OF 2                                                         !City/State tab
        ?BROWSE:1{PROP:Format} =  '24L|M~State~@s2@#3#'   & |      !  State
                                  '80L|M~City~@s25@#2#'    & |     !  City
                                  '180L|M~Name~@s45@#1# '          !  Name
      END
    END
  ReturnValue = PARENT.TakeNewSelection()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


BRW1.SetQueueRecord PROCEDURE

  CODE
  LastFirst = CLIP(PEO:LastName) & ', ' & CLIP(PEO:FirstName)
  PARENT.SetQueueRecord
  SELF.Q.LastFirst = LastFirst                        !Assign formula result to display queue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves=False
  SELF.SetParentDefaults

Maillist_BrowseStateFile PROCEDURE                    !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(STATES)
                       PROJECT(STA:CODE)
                       PROJECT(STA:NAME)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
STA:CODE               LIKE(STA:CODE)                 !List box control field - type derived from field
STA:NAME               LIKE(STA:NAME)                 !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('State Listing'),AT(,,164,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~StateListing'),SYSTEM,GRAY,MDI
                       PANEL,AT(3,3,155,161),USE(?Panel1)
                       LIST,AT(8,29,144,130),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),TIP('State list'),FORMAT('27C(2)|M~CODE~L@s2@80L(2)|M~NAME~@s25@'),FROM(Queue:Browse:1)
                       STRING('Type a letter to locate a state by code'),AT(10,7),USE(?String1)
                       STRING(@s2),AT(11,17),USE(STA:CODE)
                       BUTTON('&Select'),AT(40,105,47,14),USE(?Select:2),HIDE
                       BUTTON('&Insert'),AT(37,50,45,14),USE(?Insert:3),HIDE
                       BUTTON('&Change'),AT(35,70,45,14),USE(?Change:3),HIDE,DEFAULT
                       PANEL,AT(3,166,155,32),USE(?Panel2)
                       BUTTON('&Delete'),AT(37,88,45,14),USE(?Delete:3),HIDE
                       BUTTON('Close'),AT(7,171,72,23),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Save and exit window'),TIP('Save & exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(82,171,72,23),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  FilterLocatorClass               !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
BRW1::EIPManager     BrowseEIPManager                 !Browse EIP Manager for Browse using ?Browse:1
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_BrowseStateFile')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:STATES.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:STATES,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,STA:STATEKEY)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?STA:CODE,STA:CODE,1,BRW1)
  BRW1.AddField(STA:CODE,BRW1.Q.STA:CODE)
  BRW1.AddField(STA:NAME,BRW1.Q.STA:NAME)
  Resizer.Init(AppStrategy:Spread)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Maillist_BrowseStateFile',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:STATES.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_BrowseStateFile',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW1::EIPManager
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves=False
  SELF.SetParentDefaults

ProcessExportFile PROCEDURE                           !Generated from procedure template - Process

FilesOpened          BYTE
LOC:FileName         STRING(90)
Progress:Thermometer BYTE
Process:View         VIEW(People)
                     END
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisProcess          CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepClass                        !Progress Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('ProcessExportFile')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  !Get current path and file name for screen display
  LOC:Filename = CLIP(PATH())&'\PEOPLE.CSV'
  Relate:EXPORT.Open
  Relate:People.Open
  SELF.FilesOpened = True
  !Clear the target if it exists
  EMPTY(EXPORT)
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('ProcessExportFile',ProgressWindow)
  ThisProcess.Init(Process:View, Relate:People, ?Progress:PctText, Progress:Thermometer)
  ThisProcess.AddSortOrder()
  ProgressWindow{Prop:Text} = 'Processing Records'
  ?Progress:PctText{Prop:Text} = '0% Completed'
  SELF.Init(ThisProcess)
  ?Progress:UserString{Prop:Text}='Copying data to ASCII file'
  SELF.AddItem(?Progress:Cancel, RequestCancelled)
  SEND(People,'QUICKSCAN=on')
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EXPORT.Close
    Relate:People.Close
  END
  IF SELF.Opened
    INIMgr.Update('ProcessExportFile',ProgressWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisProcess.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.TakeRecord()
  !code for creating ascii file
  EXP:Record :=: PEO:Record              !Assign fields from source to target
  Access:Export.Insert()                 !Add to target
  RETURN ReturnValue

Maillist_WindowExportFile PROCEDURE                   !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
DOSDialogHeader      CSTRING(40)
DOSExtParameter      CSTRING(250)
DOSTargetVariable    CSTRING(80)
LOC:Filename         STRING(90)
window               WINDOW('People Data Export Information'),AT(,,226,62),CENTER,ICON('MAIL10.ICO'),HLP('~ExportWindow'),SYSTEM,GRAY,MDI,IMM
                       BUTTON('Export File'),AT(78,41,69,17),USE(?Export),LEFT,FONT('Arial',12,,FONT:bold),ICON(ICON:New)
                       PANEL,AT(3,38,220,23),USE(?Panel2)
                       BUTTON('Cancel'),AT(6,41,69,17),USE(?Cancel),LEFT,FONT('Arial',12,COLOR:Red,FONT:bold),MSG('Exit window '),TIP('Exit window'),ICON(ICON:Cross)
                       BUTTON('Help'),AT(150,41,69,17),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,4,221,31),USE(?Panel1)
                       STRING('The personal profile data will be exported to the following file:'),AT(6,8),USE(?String3)
                       STRING(@s90),AT(7,23,214,10),USE(LOC:Filename),CENTER,FONT('Arial',10,,FONT:bold)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_WindowExportFile')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Export
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  !Get current path and file name for screen display
  LOC:Filename = CLIP(PATH())&'\PEOPLE.CSV'
  SELF.AddItem(?Cancel,RequestCancelled)
  OPEN(window)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_WindowExportFile',window)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Maillist_WindowExportFile',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Export
      ThisWindow.Update
      ProcessExportFile
      ThisWindow.Reset
       POST(Event:CloseWindow)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

WindowSB PROCEDURE                                    !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
AuthorText           STRING(1000)
window               WINDOW('About the Author'),AT(,,164,118),FONT('Arial',9,COLOR:White,FONT:regular+FONT:italic),COLOR(COLOR:Navy),ICON('MAIL10.ICO'),SYSTEM,GRAY,MDI,IMM
                       TEXT,AT(1,0,161,115),USE(AuthorText),DISABLE,FONT('Arial',9,COLOR:Silver,FONT:bold+FONT:italic)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('WindowSB')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?AuthorText
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  !Set text for screen
  AuthorText = 'Sue Bostic started with TopSpeed Corporation in August of 1995, ' &|
               'as a Tech Support Rep. She performed dual duty ' &|
               'as Manager of Technical Support and Manager of Internal System ' &|
               'Programming.  As the Manager of Technical support, she oversaw ' &|
               'the phone support of current products, as well the ' &|
               'duties of SysOp on the CIS TopSpeed Forum .  In the area of ' &|
               'Internal Systems Programming, she was responsible for maintaining ' &|
               'current operating programs and developing new systems used ' &|
               'by Topspeed Corporation, which were all developed using Clarion ' &|
               'products.'
  OPEN(window)
  SELF.Opened=True
  INIMgr.Fetch('WindowSB',window)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('WindowSB',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue

