

   MEMBER('Eventmgr.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABDROPS.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EVENT002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EVENT001.INC'),ONCE        !Req'd for module callout resolution
                     END


ShowMemberToolbox PROCEDURE                           !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
FilterFlag           BYTE
LOC:Running:ShowMemberToolBox LONG(0)
BRW1::View:Browse    VIEW(Members)
                       PROJECT(MEM:LastName)
                       PROJECT(MEM:FirstName)
                       PROJECT(MEM:Active)
                       PROJECT(MEM:MemberNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
MEM:LastName           LIKE(MEM:LastName)             !List box control field - type derived from field
MEM:LastName_Icon      LONG                           !Entry's icon ID
MEM:FirstName          LIKE(MEM:FirstName)            !List box control field - type derived from field
MEM:Active             LIKE(MEM:Active)               !Browse hot field - type derived from field
MEM:MemberNumber       LIKE(MEM:MemberNumber)         !Browse hot field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a Member'),AT(,,181,214),FONT('MS Sans Serif',8,,),IMM,HLP('SelectMembers'),SYSTEM,TOOLBOX,GRAY,RESIZE,MDI
                       SHEET,AT(2,3,176,209),USE(?Sheet1)
                         TAB('&Active'),USE(?Tab1)
                         END
                         TAB('&Inactive'),USE(?Tab2)
                         END
                         TAB('A&ll'),USE(?Tab3)
                         END
                       END
                       LIST,AT(11,22,157,183),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),CURSOR('FINGER.CUR'),FORMAT('71L(2)|MI~LastName~@s25@80L(2)|M~FirstName~@s20@'),FROM(Queue:Browse:1),DRAGID('''SelectMembers''')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
TakeKey                PROCEDURE(),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort1:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=1
BRW1::Sort2:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=2
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()

DragFromMemberList   ROUTINE
! This Routine Gets the record for the Highlighted item in the List
! so a person can be assigned to attend an event
  GET(QUEUE:BROWSE:1,CHOICE(?Browse:1))
  SETCLIPBOARD(BRW1.Q.MEM:MemberNumber)

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('ShowMemberToolbox')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  !!Limit to only one instance
    IF NOT GLO:Running:ShowMemberToolbox     !If its not running
      GLO:Running:ShowMemberToolbox=THREAD()  !Set global var to indicate this instance is running
      LOC:Running:ShowMemberToolbox=THREAD()  !Set Local var to indicate this instance is running
    ELSE                                 !If it is running
      POST(Event:GainFocus,,GLO:Running:ShowMemberToolbox) !bring to front
      RETURN Level:Fatal  !don't continute this with this instance
    END
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Members.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Members,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1.AddSortOrder(,MEM:NameKey)
  BRW1.AddLocator(BRW1::Sort1:Locator)
  BRW1::Sort1:Locator.Init(,MEM:LastName,1,BRW1)
  BRW1.SetFilter('(MEM:Active=1)')
  BRW1.AddSortOrder(,MEM:NameKey)
  BRW1.AddLocator(BRW1::Sort2:Locator)
  BRW1::Sort2:Locator.Init(,MEM:LastName,1,BRW1)
  BRW1.SetFilter('(MEM:Active=0)')
  BRW1.AddResetField(FilterFlag)
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Name)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,MEM:NameKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,MEM:LastName,1,BRW1)
  BRW1.AddResetField(FilterFlag)
  ?Browse:1{PROP:IconList,1} = '~check.ico'
  ?Browse:1{PROP:IconList,2} = '~uncheck.ico'
  BRW1.AddField(MEM:LastName,BRW1.Q.MEM:LastName)
  BRW1.AddField(MEM:FirstName,BRW1.Q.MEM:FirstName)
  BRW1.AddField(MEM:Active,BRW1.Q.MEM:Active)
  BRW1.AddField(MEM:MemberNumber,BRW1.Q.MEM:MemberNumber)
  Resizer.Init(AppStrategy:Spread)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('ShowMemberToolbox',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Members.Close
  END
  IF SELF.Opened
    INIMgr.Update('ShowMemberToolbox',QuickWindow)
  END
  !!Reset Thread Limiting flag
  IF LOC:Running:ShowMemberToolbox
     GLO:Running:ShowMemberToolbox = 0
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?Browse:1
    CASE EVENT()
    OF EVENT:Drag
      DO DragFromMemberList
      
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
  CASE FIELD()
  OF ?Browse:1
    CASE EVENT()
    OF EVENT:Dragging
      SETCURSOR(CHOOSE(DROPID(),'~dropmbr.cur',Cursor:NoDrop))
      
    OF EVENT:Drag
      SETCURSOR()
      
    END
  END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:GainFocus
      !!Bring to front and restore to normal size if iconized
      quickwindow{PROP:Active}=TRUE
      IF quickwindow{PROP:Iconize}=TRUE
        quickwindow{PROP:Iconize}=''
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?Sheet1)=1
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?Sheet1)=2
    RETURN SELF.SetSort(2,Force)
  ELSE
    RETURN SELF.SetSort(3,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


BRW1.SetQueueRecord PROCEDURE

  CODE
  PARENT.SetQueueRecord
  IF (CHOICE(?Sheet1)=3 AND MEM:Active)
    SELF.Q.MEM:LastName_Icon = 1
  ELSIF (CHOICE(?Sheet1)=3 AND ~MEM:Active)
    SELF.Q.MEM:LastName_Icon = 2
  ELSE
    SELF.Q.MEM:LastName_Icon = 0
  END


BRW1.TakeKey PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  IF RECORDS(SELF.ListQueue)
    CASE KEYCODE()
    OF MouseLeft2
      !!mimic Drag and drop  for double-click
      DO DragFromMemberList
      POST(Event:Drop,GLO:AttendeeList,GLO:Running:BrowseEvents)
    END
  END
  
  ReturnValue = PARENT.TakeKey()
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults
  SELF.SetStrategy(?Browse:1, Resize:LockXPos+Resize:LockYPos, Resize:ConstantRight+Resize:ConstantBottom)
  SELF.SetStrategy(?Sheet1, Resize:LockXPos+Resize:LockYPos, Resize:ConstantRight+Resize:ConstantBottom)

DOW                  PROCEDURE  (InDate)              ! Declare Procedure
DayGroup             GROUP,PRE()
S1                   STRING('Sunday {3}')
S2                   STRING('Monday {3}')
S3                   STRING('Tuesday {2}')
S4                   STRING('Wednesday')
S5                   STRING('Thursday {1}')
S6                   STRING('Friday {3}')
S7                   STRING('Saturday {1}')
                     END
WhichDay             STRING(9),DIM(7),OVER(DayGroup)
  CODE
RETURN(WhichDay[(InDate % 7) + 1])
Eventmgr_Main PROCEDURE                               !Generated from procedure template - Frame

LocalRequest         LONG
FilesOpened          BYTE
CurrentTab           STRING(80)
SplashProcedureThread LONG
AppFrame             APPLICATION('Event Manager'),AT(,,421,250),FONT('MS Sans Serif',8,,),CENTER,ICON('A.ICO'),HLP('~Main'),STATUS(-1,80,120,45),WALLPAPER('Eventmgr.bmp'),TILED,SYSTEM,MAX,RESIZE,IMM
                       MENUBAR
                         MENU('&File')
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('&User Preferences...'),USE(?FilePreferences),MSG('Set User Preferences for the Program')
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit the Program'),STD(STD:Close)
                         END
                         MENU('&Edit')
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),MSG('Browse Records')
                           ITEM('Browse &Members<9>F3'),USE(?BrowseMembers),MSG('Browse Members'),KEY(F3Key)
                           ITEM('Browse &Vendors<9>F4'),USE(?BrowseVendor),MSG('Browse Vendor'),KEY(F4Key)
                           ITEM('Browse &Events<9>F5'),USE(?BrowseEvents),MSG('Browse Events'),KEY(F5Key)
                           ITEM('Browse &Sponsers<9>F6'),USE(?BrowseSponser),MSG('Browse Sponser'),KEY(F6Key)
                         END
                         MENU('&Reports'),USE(?ReportMenu),MSG('Reports')
                           MENU('&Event Reports'),USE(?PrintEvents),MSG('Print Reports for an Event')
                             ITEM('Print Event &Invoice'),USE(?PrintEventInvoice),MSG('Print an Invoice for an Event')
                             ITEM('Print Event &Summary'),USE(?PrintEventSummary),MSG('Print Summary for an Event')
                             ITEM('Print Name &Badges'),USE(?PrintNameBadges),MSG('Print Name Badges for an Event')
                             ITEM('Print Event Seating &List'),USE(?PrintEventSeatingList),MSG('Print Table Seating Assignments for an Event')
                             ITEM('Print &Place Cards'),USE(?PrintPlaceCards),MSG('Print Table Place Cards for an Event')
                           END
                           MENU('&VendorReports'),USE(?ReportsVendorReports),MSG('Vendor Reports')
                             ITEM('Print &Vendor List'),USE(?PrintVendorList),MSG('Print Vendior List')
                             ITEM('Print Vendor &Labels'),USE(?PrintVendorLabels),MSG('Print Vendor Mailing Labels')
                           END
                           MENU('&Sponsor Reports'),USE(?SponsorReports),MSG('Sponsor Reports')
                             ITEM('Print &Sponsor List'),USE(?PrintSponsorList),MSG('Print List of Event Sponsors')
                             ITEM('Print Sponsor &Labels'),USE(?PrintSponsorLabels),MSG('Print Mailing Labels for all Sponsors')
                           END
                           MENU('&Member Reports'),USE(?PrintMembers),MSG('Member Reports')
                             ITEM('Print &Member List'),USE(?PrintMemberList),MSG('Print Member List')
                             ITEM('Print Member &Labels'),USE(?PrintMemberLabels),MSG('Print Mailing Labels for all Members')
                           END
                         END
                         MENU('&Window'),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),MSG('On-line Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                           ITEM('&About Event Manager...'),USE(?HelpAboutEventManager),MSG('Information on this program')
                         END
                       END
                       TOOLBAR,AT(0,0,400,16)
                         BUTTON,AT(2,2,16,14),USE(?MemberButton),TIP('Browse Members'),ICON('MEMBER.ICO'),FLAT
                         BUTTON,AT(18,2,16,14),USE(?VendorButton),TIP('Browse Vendors'),ICON('VENDOR.ICO'),FLAT
                         BUTTON,AT(34,2,16,14),USE(?EventButton),TIP('Browse Events'),ICON('EVENT.ICO'),FLAT
                         BUTTON,AT(50,2,16,14),USE(?SponsorButton),TIP('Browse Sponsors'),ICON('HNDSHAKE.ICO'),FLAT
                         BUTTON,AT(313,2,16,14),USE(?Button7),TIP('Exit Program'),ICON('EXIT3.ICO'),FLAT
                         BUTTON,AT(87,2,16,14),USE(?Toolbar:Top,Toolbar:Top),DISABLE,TIP('Go to the First Page'),ICON('VCRFIRST.ICO'),FLAT
                         BUTTON,AT(103,2,16,14),USE(?Toolbar:PageUp,Toolbar:PageUp),DISABLE,TIP('Go to the Prior Page'),ICON('VCRPRIOR.ICO'),FLAT
                         BUTTON,AT(119,2,16,14),USE(?Toolbar:Up,Toolbar:Up),DISABLE,TIP('Go to the Prior Record'),ICON('VCRUP.ICO'),FLAT
                         BUTTON,AT(135,2,16,14),USE(?Toolbar:Locate,Toolbar:Locate),DISABLE,TIP('Locate record'),ICON('FIND.ICO'),FLAT
                         BUTTON,AT(151,2,16,14),USE(?Toolbar:Down,Toolbar:Down),DISABLE,TIP('Go to the Next Record'),ICON('VCRDOWN.ICO'),FLAT
                         BUTTON,AT(167,2,16,14),USE(?Toolbar:PageDown,Toolbar:PageDown),DISABLE,TIP('Go to the Next Page'),ICON('VCRNEXT.ICO'),FLAT
                         BUTTON,AT(183,2,16,14),USE(?Toolbar:Bottom,Toolbar:Bottom),DISABLE,TIP('Go to the Last Page'),ICON('VCRLAST.ICO'),FLAT
                         BUTTON,AT(203,2,16,14),USE(?Toolbar:Select,Toolbar:Select),DISABLE,TIP('Select This Record'),ICON('MARK.ICO'),FLAT
                         BUTTON,AT(219,2,16,14),USE(?Toolbar:Insert,Toolbar:Insert),DISABLE,TIP('Insert a New Record'),ICON('INSERT.ICO'),FLAT
                         BUTTON,AT(235,2,16,14),USE(?Toolbar:Change,Toolbar:Change),DISABLE,TIP('Edit This Record'),ICON('EDIT.ICO'),FLAT
                         BUTTON,AT(251,2,16,14),USE(?Toolbar:Delete,Toolbar:Delete),DISABLE,TIP('Delete This Record'),ICON('DELETE.ICO'),FLAT
                         BUTTON,AT(271,2,16,14),USE(?Toolbar:History,Toolbar:History),DISABLE,TIP('Previous value'),ICON('DITTO.ICO'),FLAT
                         BUTTON,AT(287,2,16,14),USE(?Toolbar:Help,Toolbar:Help),DISABLE,TIP('Get Help'),ICON('HELP.ICO'),FLAT
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()

Menu::ReportMenu ROUTINE                              !Code for menu items on ?ReportMenu
Menu::PrintEvents ROUTINE                             !Code for menu items on ?PrintEvents
  CASE ACCEPTED()
  OF ?PrintEventInvoice
    START(Eventmgr_PrintEventInvoice, 50000)
  OF ?PrintEventSummary
    START(Eventmgr_PrintEventSummary, 050000)
  OF ?PrintNameBadges
    START(Eventmgr_PrintNameBadges, 50000)
  OF ?PrintEventSeatingList
    START(Eventmgr_PrintTableSeatingList, 50000)
  OF ?PrintPlaceCards
    START(Eventmgr_PrintPlaceCards, 50000)
  END
Menu::ReportsVendorReports ROUTINE                    !Code for menu items on ?ReportsVendorReports
  CASE ACCEPTED()
  OF ?PrintVendorList
    START(Eventmgr_PrintVendorList, 050000)
  OF ?PrintVendorLabels
    START(Eventmgr_PrintVendorLabels, 50000)
  END
Menu::SponsorReports ROUTINE                          !Code for menu items on ?SponsorReports
  CASE ACCEPTED()
  OF ?PrintSponsorList
    START(Eventmgr_PrintSponsorList, 050000)
  OF ?PrintSponsorLabels
    START(Eventmgr_PrintSponsorLabels, 50000)
  END
Menu::PrintMembers ROUTINE                            !Code for menu items on ?PrintMembers
  CASE ACCEPTED()
  OF ?PrintMemberList
    START(Eventmgr_PrintMemberList, 050000)
  OF ?PrintMemberLabels
    START(Eventmgr_PrintMemberLabels, 050000)
  END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_Main')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(AppFrame)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_Main',AppFrame)
  SYSTEM{PROP:Icon}='~a.ICO'
  !Assign Thread Number and Control Numbers to Global Vars
  GLO:AppFrameThread = THREAD()
  GLO:MemberButton  = ?MemberButton
  GLO:VendorButton  = ?VendorButton
  GLO:EventButton   = ?EventButton
  GLO:SponsorButton = ?SponsorButton
  
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Eventmgr_Main',AppFrame)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Button7
       POST(Event:CloseWindow)
    OF ?Toolbar:Top
    OROF ?Toolbar:PageUp
    OROF ?Toolbar:Up
    OROF ?Toolbar:Locate
    OROF ?Toolbar:Down
    OROF ?Toolbar:PageDown
    OROF ?Toolbar:Bottom
    OROF ?Toolbar:Select
    OROF ?Toolbar:Insert
    OROF ?Toolbar:Change
    OROF ?Toolbar:Delete
    OROF ?Toolbar:History
    OROF ?Toolbar:Help
      IF SYSTEM{PROP:Active} <> THREAD()
        POST(EVENT:Accepted,ACCEPTED(),SYSTEM{Prop:Active} )
        CYCLE
      END
    ELSE
      DO Menu::ReportMenu                             !Process menu items on ?ReportMenu menu
      DO Menu::PrintEvents                            !Process menu items on ?PrintEvents menu
      DO Menu::ReportsVendorReports                   !Process menu items on ?ReportsVendorReports menu
      DO Menu::SponsorReports                         !Process menu items on ?SponsorReports menu
      DO Menu::PrintMembers                           !Process menu items on ?PrintMembers menu
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?FilePreferences
      Eventmgr_Preferences(FALSE)
    OF ?BrowseMembers
      START(Eventmgr_BrowseMembers, 050000)
    OF ?BrowseVendor
      START(Eventmgr_BrowseVendors, 050000)
    OF ?BrowseEvents
      START(Eventmgr_BrowseEvents, 050000)
    OF ?BrowseSponser
      START(Eventmgr_BrowseSponsors, 050000)
    OF ?HelpAboutEventManager
      Eventmgr_HelpAbout
    OF ?MemberButton
      START(Eventmgr_BrowseMembers, 25000)
    OF ?VendorButton
      START(Eventmgr_BrowseVendors, 25000)
    OF ?EventButton
      START(Eventmgr_BrowseEvents, 25000)
    OF ?SponsorButton
      START(Eventmgr_BrowseSponsors, 25000)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:OpenWindow
      SplashProcedureThread = START(Eventmgr_SplashScreen)
    ELSE
      IF SplashProcedureThread
        IF EVENT() = Event:Accepted
          POST(Event:CloseWindow,,SplashProcedureThread)
          SplashPRocedureThread = 0
        END
     END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

UpdateMembers PROCEDURE                               !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
Queue:FileDropCombo  QUEUE                            !Queue declaration for browse/combo box using ?MEM:MemberType
MTY:TypeCode           LIKE(MTY:TypeCode)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW5::View:Browse    VIEW(MPhones)
                       PROJECT(MPH:Description)
                       PROJECT(MPH:PhoneNumber)
                       PROJECT(MPH:MemberNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
MPH:Description        LIKE(MPH:Description)          !List box control field - type derived from field
MPH:PhoneNumber        LIKE(MPH:PhoneNumber)          !List box control field - type derived from field
MPH:MemberNumber       LIKE(MPH:MemberNumber)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
FDCB7::View:FileDropCombo VIEW(MemberType)
                       PROJECT(MTY:TypeCode)
                     END
History::MEM:Record  LIKE(MEM:RECORD),STATIC
QuickWindow          WINDOW('Update Members'),AT(,,227,211),FONT('MS Sans Serif',8,,),IMM,HLP('~UpdateMember'),GRAY,MAX,RESIZE,MDI
                       PROMPT('Number:'),AT(22,1),USE(?MEM:MemberNumber:Prompt)
                       STRING(@n4),AT(53,2,28,10),USE(MEM:MemberNumber),RIGHT(1),FONT(,,,FONT:bold)
                       PROMPT('&LastName:'),AT(15,17),USE(?MEM:LastName:Prompt)
                       ENTRY(@s25),AT(54,17,104,10),USE(MEM:LastName),REQ
                       PROMPT('&FirstName:'),AT(16,30),USE(?MEM:FirstName:Prompt)
                       ENTRY(@s20),AT(54,31,84,10),USE(MEM:FirstName)
                       ENTRY(@s1),AT(143,31,15,10),USE(MEM:MiddleName)
                       GROUP('&Phones:'),AT(20,45,167,60),USE(?Group1),BOXED
                         LIST,AT(54,56,127,43),USE(?List),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('40L|M~Description~@s10@80L|M~Number~@s20@'),FROM(Queue:Browse)
                         BUTTON,AT(30,56,16,14),USE(?Insert),TIP('Add a Phone Number'),ICON('INSERT.ICO')
                         BUTTON,AT(30,71,16,14),USE(?Change),TIP('Change a Phone Number'),ICON('EDIT.ICO')
                         BUTTON,AT(30,87,16,14),USE(?Delete),TIP('Delete a Phone Number'),ICON('DELETE.ICO')
                       END
                       PROMPT('&Address:'),AT(22,109),USE(?MEM:Address:Prompt)
                       ENTRY(@s40),AT(54,108,164,10),USE(MEM:Address)
                       ENTRY(@s40),AT(54,121,164,10),USE(MEM:Address2)
                       PROMPT('&City:'),AT(36,132),USE(?MEM:City:Prompt)
                       ENTRY(@s25),AT(54,132,104,10),USE(MEM:City)
                       PROMPT('&State:'),AT(30,145),USE(?MEM:State:Prompt)
                       ENTRY(@s2),AT(54,144,40,10),USE(MEM:State)
                       PROMPT('&ZIP:'),AT(99,145),USE(?MEM:ZipCode:Prompt)
                       ENTRY(@s10),AT(116,144,44,10),USE(MEM:ZIPCode)
                       PROMPT('Date &Join:'),AT(19,159),USE(?MEM:DateJoin:Prompt)
                       SPIN(@d2),AT(54,159,52,10),USE(MEM:DateJoin),RIGHT(1),STEP(1)
                       CHECK('&Active'),AT(119,159),USE(MEM:Active)
                       PROMPT('&Type:'),AT(31,175),USE(?Prompt11)
                       COMBO(@s15),AT(53,175,119,10),USE(MEM:MemberType),FORMAT('60L~Type Code~@s15@'),DROP(5),FROM(Queue:FileDropCombo)
                       BUTTON('OK'),AT(33,190,45,14),USE(?OK),TIP('Save the Member Record'),DEFAULT
                       BUTTON('Cancel'),AT(91,190,45,14),USE(?Cancel),TIP('Close the window and cancel changes')
                       BUTTON('Help'),AT(149,190,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

BRW5                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW5::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW5::EIPManager     BrowseEIPManager                 !Browse EIP Manager for Browse using ?List
FDCB7                CLASS(FileDropComboClass)        !File drop combo manager
Q                      &Queue:FileDropCombo           !Reference to browse queue type
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Members Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Members Record'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateMembers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?MEM:MemberNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(MEM:Record,History::MEM:Record)
  SELF.AddHistoryField(?MEM:MemberNumber,1)
  SELF.AddHistoryField(?MEM:LastName,2)
  SELF.AddHistoryField(?MEM:FirstName,3)
  SELF.AddHistoryField(?MEM:MiddleName,4)
  SELF.AddHistoryField(?MEM:Address,5)
  SELF.AddHistoryField(?MEM:Address2,6)
  SELF.AddHistoryField(?MEM:City,7)
  SELF.AddHistoryField(?MEM:State,8)
  SELF.AddHistoryField(?MEM:ZIPCode,9)
  SELF.AddHistoryField(?MEM:DateJoin,10)
  SELF.AddHistoryField(?MEM:Active,11)
  SELF.AddHistoryField(?MEM:MemberType,12)
  SELF.AddUpdateFile(Access:Members)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:MPhones.Open
  Relate:MemberType.Open
  Relate:States.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Members
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW5.Init(?List,Queue:Browse.ViewPosition,BRW5::View:Browse,Queue:Browse,Relate:MPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  BRW5.Q &= Queue:Browse
  BRW5.AddSortOrder(,MPH:KeyMemberNumber)
  BRW5.AddRange(MPH:MemberNumber,Relate:MPhones,Relate:Members)
  BRW5.AddLocator(BRW5::Sort0:Locator)
  BRW5::Sort0:Locator.Init(,MPH:MemberNumber,1,BRW5)
  BRW5.AddField(MPH:Description,BRW5.Q.MPH:Description)
  BRW5.AddField(MPH:PhoneNumber,BRW5.Q.MPH:PhoneNumber)
  BRW5.AddField(MPH:MemberNumber,BRW5.Q.MPH:MemberNumber)
  INIMgr.Fetch('UpdateMembers',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  FDCB7.Init(MEM:MemberType,?MEM:MemberType,Queue:FileDropCombo.ViewPosition,FDCB7::View:FileDropCombo,Queue:FileDropCombo,Relate:MemberType,ThisWindow,GlobalErrors,1,1,0)
  FDCB7.Q &= Queue:FileDropCombo
  FDCB7.AddSortOrder()
  FDCB7.AddField(MTY:TypeCode,FDCB7.Q.MTY:TypeCode)
  FDCB7.AddUpdateField(MTY:TypeCode,MEM:MemberType)
  ThisWindow.AddItem(FDCB7.WindowComponent)
  FDCB7.DefaultFill = 0
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MPhones.Close
    Relate:MemberType.Close
    Relate:States.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateMembers',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.PrimeFields PROCEDURE

  CODE
    MEM:City = DefaultCity
    MEM:State = DefaultState
    MEM:ZIPCode = DefaultZip
    MEM:DateJoin = TODAY()
    MEM:Active = 1
  PARENT.PrimeFields


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    BrowseStates
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?MEM:State
      ST:StateCode = MEM:State
      IF Access:States.TryFetch(ST:StateKey)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          MEM:State = ST:StateCode
        ELSE
          SELECT(?MEM:State)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:Members.TryValidateField(8)
        SELECT(?MEM:State)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?MEM:State
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?MEM:State{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?MEM:MemberType
      IF Access:Members.TryValidateField(12)
        SELECT(?MEM:MemberType)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?MEM:MemberType
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?MEM:MemberType{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    Quickwindow{Prop:Text}= ACTIONMESSAGE & '--' & MEM:LastName
  
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults


BRW5.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW5::EIPManager
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

Eventmgr_BrowseMembers PROCEDURE                      !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LOC:MemberName       STRING(40)
LOC:Running:BrowseMembers LONG(0)
LOC:FullAddress      STRING(200)
BRW1::View:Browse    VIEW(Members)
                       PROJECT(MEM:Address)
                       PROJECT(MEM:Address2)
                       PROJECT(MEM:City)
                       PROJECT(MEM:State)
                       PROJECT(MEM:ZIPCode)
                       PROJECT(MEM:DateJoin)
                       PROJECT(MEM:MemberType)
                       PROJECT(MEM:Active)
                       PROJECT(MEM:MemberNumber)
                       PROJECT(MEM:LastName)
                       PROJECT(MEM:FirstName)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
LOC:MemberName         LIKE(LOC:MemberName)           !List box control field - type derived from local data
LOC:MemberName_NormalFG LONG                          !Normal forground color
LOC:MemberName_NormalBG LONG                          !Normal background color
LOC:MemberName_SelectedFG LONG                        !Selected forground color
LOC:MemberName_SelectedBG LONG                        !Selected background color
MEM:Address            LIKE(MEM:Address)              !Browse hot field - type derived from field
MEM:Address2           LIKE(MEM:Address2)             !Browse hot field - type derived from field
MEM:City               LIKE(MEM:City)                 !Browse hot field - type derived from field
MEM:State              LIKE(MEM:State)                !Browse hot field - type derived from field
MEM:ZIPCode            LIKE(MEM:ZIPCode)              !Browse hot field - type derived from field
MEM:DateJoin           LIKE(MEM:DateJoin)             !Browse hot field - type derived from field
MEM:MemberType         LIKE(MEM:MemberType)           !Browse hot field - type derived from field
MEM:Active             LIKE(MEM:Active)               !Browse hot field - type derived from field
LOC:FullAddress        LIKE(LOC:FullAddress)          !Browse hot field - type derived from local data
MEM:MemberNumber       LIKE(MEM:MemberNumber)         !Primary key field - type derived from field
MEM:LastName           LIKE(MEM:LastName)             !Browse key field - type derived from field
MEM:FirstName          LIKE(MEM:FirstName)            !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW6::View:Browse    VIEW(MPhones)
                       PROJECT(MPH:Description)
                       PROJECT(MPH:PhoneNumber)
                       PROJECT(MPH:MemberNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
MPH:Description        LIKE(MPH:Description)          !List box control field - type derived from field
MPH:PhoneNumber        LIKE(MPH:PhoneNumber)          !List box control field - type derived from field
MPH:MemberNumber       LIKE(MPH:MemberNumber)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Members'),AT(,,283,173),FONT('MS Sans Serif',8,,),ICON('MEMBER.ICO'),HLP('~BrowseMembers'),SYSTEM,GRAY,RESIZE,MDI,IMM
                       LIST,AT(8,20,109,124),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('80L(2)|M*~Member Name~S(20)@s40@'),FROM(Queue:Browse:1)
                       BUTTON('&Insert'),AT(24,113,19,14),USE(?Insert:2),HIDE
                       BUTTON('&Change'),AT(45,113,22,14),USE(?Change:2),HIDE,DEFAULT
                       BUTTON('&Delete'),AT(71,113,23,14),USE(?Delete:2),HIDE
                       STRING(@d2),AT(179,76),USE(MEM:DateJoin)
                       TEXT,AT(128,31,129,40),USE(LOC:FullAddress),SKIP,COLOR(COLOR:BTNFACE),READONLY
                       PROMPT('Date Joined:'),AT(137,76),USE(?MEM:DateJoin:Prompt)
                       STRING(@s15),AT(179,85),USE(MEM:MemberType)
                       PROMPT('Member Type:'),AT(131,85),USE(?MEM:MemberType:Prompt)
                       PANEL,AT(119,20,146,124),USE(?Panel1),BEVEL(-2,-2)
                       LIST,AT(127,98,130,40),USE(?List),IMM,VSCROLL,COLOR(COLOR:BTNFACE),MSG('Browsing Records'),FORMAT('40L|M@s10@80L|M@s20@'),FROM(Queue:Browse)
                       SHEET,AT(4,4,266,148),USE(?CurrentTab)
                         TAB('By Name')
                         END
                         TAB('By Zip Code')
                         END
                       END
                       BUTTON('Close'),AT(170,156,45,14),USE(?Close)
                       BUTTON('Help'),AT(226,156,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort1:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
BRW1::Sort1:StepClass StepStringClass                 !Conditional Step Manager - CHOICE(?CurrentTab) = 2
BRW6                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
                     END

BRW6::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW6::Sort0:StepClass StepLongClass                   !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_BrowseMembers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  ALERT(F3Key,F6Key)
  !!Limit to only one instance
   IF GlobalRequest<>SelectRecord
    IF NOT GLO:Running:BrowseMembers     !If its not running
      GLO:Running:BrowseMembers=THREAD()  !Set global var to indicate this instance is running
      LOC:Running:BrowseMembers=THREAD()  !Set Local var to indicate this instance is running
    ELSE                                 !If it is running
      POST(Event:GainFocus,,GLO:Running:BrowseMembers) !bring to front
      RETURN Level:Fatal  !don't continute this with this instance
    END
   END
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MPhones.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Members,SELF)
  BRW6.Init(?List,Queue:Browse.ViewPosition,BRW6::View:Browse,Queue:Browse,Relate:MPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,MEM:ZipCodeKey)
  BRW1.AddLocator(BRW1::Sort1:Locator)
  BRW1::Sort1:Locator.Init(,MEM:ZIPCode,1,BRW1)
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,MEM:NameKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,MEM:LastName,1,BRW1)
  BIND('LOC:MemberName',LOC:MemberName)
  BIND('LOC:FullAddress',LOC:FullAddress)
  BRW1.AddField(LOC:MemberName,BRW1.Q.LOC:MemberName)
  BRW1.AddField(MEM:Address,BRW1.Q.MEM:Address)
  BRW1.AddField(MEM:Address2,BRW1.Q.MEM:Address2)
  BRW1.AddField(MEM:City,BRW1.Q.MEM:City)
  BRW1.AddField(MEM:State,BRW1.Q.MEM:State)
  BRW1.AddField(MEM:ZIPCode,BRW1.Q.MEM:ZIPCode)
  BRW1.AddField(MEM:DateJoin,BRW1.Q.MEM:DateJoin)
  BRW1.AddField(MEM:MemberType,BRW1.Q.MEM:MemberType)
  BRW1.AddField(MEM:Active,BRW1.Q.MEM:Active)
  BRW1.AddField(LOC:FullAddress,BRW1.Q.LOC:FullAddress)
  BRW1.AddField(MEM:MemberNumber,BRW1.Q.MEM:MemberNumber)
  BRW1.AddField(MEM:LastName,BRW1.Q.MEM:LastName)
  BRW1.AddField(MEM:FirstName,BRW1.Q.MEM:FirstName)
  BRW6.Q &= Queue:Browse
  BRW6::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW6.AddSortOrder(BRW6::Sort0:StepClass,MPH:KeyMemberNumber)
  BRW6.AddRange(MPH:MemberNumber,Relate:MPhones,Relate:Members)
  BRW6.AddLocator(BRW6::Sort0:Locator)
  BRW6::Sort0:Locator.Init(,MPH:MemberNumber,1,BRW6)
  BRW6.AddField(MPH:Description,BRW6.Q.MPH:Description)
  BRW6.AddField(MPH:PhoneNumber,BRW6.Q.MPH:PhoneNumber)
  BRW6.AddField(MPH:MemberNumber,BRW6.Q.MPH:MemberNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Eventmgr_BrowseMembers',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  BRW6.AddToolbarTarget(Toolbar)
  BRW6.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MPhones.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_BrowseMembers',QuickWindow)
  END
  !!Reset Thread Limiting flag
  IF LOC:Running:BrowseMembers
     GLO:Running:BrowseMembers=0
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    UpdateMembers
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:AlertKey
      !Handle All Procedure HotKeys
      CASE KEYCODE()
        OF F3Key
            POST(EVENT:Accepted,GLO:MemberButton,GLO:AppFrameThread)
        OF F4Key
            POST(EVENT:Accepted,GLO:VendorButton,GLO:AppFrameThread)
        OF F5Key
            POST(EVENT:Accepted,GLO:EventButton,GLO:AppFrameThread)
        OF F6Key
            POST(EVENT:Accepted,GLO:SponsorButton,GLO:AppFrameThread)
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:GainFocus
      !!Bring to front and restore to normal size if iconized
      quickwindow{PROP:Active}=TRUE
      IF quickwindow{PROP:Iconize}=TRUE
        quickwindow{PROP:Iconize}=''
      END
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


BRW1.SetQueueRecord PROCEDURE

  CODE
  LOC:MemberName = CLIP(MEM:LastName) & ', ' & CLIP(MEM:FirstName) & ' ' & MEM:MiddleName
  IF (MEM:Address2)
    LOC:FullAddress = MEM:Address & '<13,10>' & MEM:Address2 & '<13,10>' & CLIP(MEM:City) & ', ' & MEM:State & ' ' & MEM:ZIPCode
  ELSE
    LOC:FullAddress = MEM:Address & '<13,10>' & CLIP(MEM:City) & ', ' & MEM:State & ' ' & MEM:ZIPCode
  END
  PARENT.SetQueueRecord
  IF (~MEM:Active)
    SELF.Q.LOC:MemberName_NormalFG = -2147483631
    SELF.Q.LOC:MemberName_NormalBG = -1
    SELF.Q.LOC:MemberName_SelectedFG = -1
    SELF.Q.LOC:MemberName_SelectedBG = -1
  ELSE
    SELF.Q.LOC:MemberName_NormalFG = -1
    SELF.Q.LOC:MemberName_NormalBG = -1
    SELF.Q.LOC:MemberName_SelectedFG = -1
    SELF.Q.LOC:MemberName_SelectedBG = -1
  END
  SELF.Q.LOC:MemberName = LOC:MemberName              !Assign formula result to display queue
  SELF.Q.LOC:FullAddress = LOC:FullAddress            !Assign formula result to display queue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

UpdateSponsor PROCEDURE                               !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
BRW2::View:Browse    VIEW(Events)
                       PROJECT(EVE:Description)
                       PROJECT(EVE:Date)
                       PROJECT(EVE:Number)
                       PROJECT(EVE:Sponsor)
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
EVE:Description        LIKE(EVE:Description)          !List box control field - type derived from field
EVE:Date               LIKE(EVE:Date)                 !List box control field - type derived from field
EVE:Number             LIKE(EVE:Number)               !Primary key field - type derived from field
EVE:Sponsor            LIKE(EVE:Sponsor)              !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW7::View:Browse    VIEW(SPhones)
                       PROJECT(SPH:Description)
                       PROJECT(SPH:PhoneNumber)
                       PROJECT(SPH:SponsorNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
SPH:Description        LIKE(SPH:Description)          !List box control field - type derived from field
SPH:PhoneNumber        LIKE(SPH:PhoneNumber)          !List box control field - type derived from field
SPH:SponsorNumber      LIKE(SPH:SponsorNumber)        !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::SPO:Record  LIKE(SPO:RECORD),STATIC
QuickWindow          WINDOW('Update a Sponser'),AT(,,221,192),FONT('MS Sans Serif',8,,),IMM,HLP('~UpdateSponser'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,203,158),USE(?CurrentTab)
                         TAB('&General')
                           PROMPT('&Company:'),AT(8,22),USE(?SPO:CompanyName:Prompt)
                           ENTRY(@S25),AT(43,23,104,10),USE(SPO:CompanyName),REQ
                           PROMPT('&Address:'),AT(12,103),USE(?SPO:Address:Prompt)
                           ENTRY(@S25),AT(43,103,136,10),USE(SPO:Address)
                           ENTRY(@S25),AT(43,116,135,10),USE(SPO:Address2)
                           PROMPT('Address&2:'),AT(8,116),USE(?SPO:Address2:Prompt)
                           PROMPT('Ci&ty:'),AT(26,130),USE(?SPO:City:Prompt)
                           ENTRY(@S25),AT(43,130,104,10),USE(SPO:City)
                           PROMPT('&State:'),AT(20,144),USE(?SPO:State:Prompt)
                           ENTRY(@s2),AT(43,144,40,10),USE(SPO:State)
                           PROMPT('&Zip:'),AT(89,144),USE(?SPO:Zip:Prompt)
                           ENTRY(@s10),AT(106,144,44,10),USE(SPO:Zip),RIGHT(1)
                           GROUP('&Phones'),AT(14,38,172,63),USE(?Group1),BOXED
                             BUTTON,AT(22,49,16,14),USE(?Insert),TIP('Add a Phone Number'),ICON('INSERT.ICO')
                             BUTTON,AT(22,63,16,14),USE(?Change),TIP('Change a Phone Number'),ICON('EDIT.ICO')
                             BUTTON,AT(22,77,16,14),USE(?Delete),TIP('Delete a Phone Number'),ICON('DELETE.ICO')
                             LIST,AT(43,49,131,46),USE(?List),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('40L|M~Description~@s10@80L|M~Number~@s20@'),FROM(Queue:Browse)
                           END
                         END
                         TAB('&Events')
                           LIST,AT(8,20,196,127),USE(?Browse:2),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('93L(2)|M~Description~@S25@80L(2)|M~Date~C(0)@d2@'),FROM(Queue:Browse:2)
                           BUTTON('&Insert'),AT(26,86,45,14),USE(?Insert:3),HIDE
                           BUTTON('&Change'),AT(91,87,45,14),USE(?Change:3),HIDE
                           BUTTON('&Delete'),AT(145,87,45,14),USE(?Delete:3),HIDE
                         END
                       END
                       BUTTON('OK'),AT(33,170,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(89,170,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(145,170,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)               !Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW2::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW2::Sort0:StepClass StepLongClass                   !Default Step Manager
BRW7                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW7::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW7::EIPManager     BrowseEIPManager                 !Browse EIP Manager for Browse using ?List
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Sponser Record'
  OF ChangeRecord
    ActionMessage = 'Changing a Sponser Record'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateSponsor')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?SPO:CompanyName:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(SPO:Record,History::SPO:Record)
  SELF.AddHistoryField(?SPO:CompanyName,2)
  SELF.AddHistoryField(?SPO:Address,3)
  SELF.AddHistoryField(?SPO:Address2,4)
  SELF.AddHistoryField(?SPO:City,5)
  SELF.AddHistoryField(?SPO:State,6)
  SELF.AddHistoryField(?SPO:Zip,7)
  SELF.AddUpdateFile(Access:Sponsor)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:Events.Open
  Relate:States.Open
  Access:Sponsor.UseFile
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Sponsor
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Events,SELF)
  BRW7.Init(?List,Queue:Browse.ViewPosition,BRW7::View:Browse,Queue:Browse,Relate:SPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,EVE:KeySponsor)
  BRW2.AddRange(EVE:Sponsor,Relate:Events,Relate:Sponsor)
  BRW2.AddLocator(BRW2::Sort0:Locator)
  BRW2::Sort0:Locator.Init(,EVE:Date,1,BRW2)
  BRW2.AddField(EVE:Description,BRW2.Q.EVE:Description)
  BRW2.AddField(EVE:Date,BRW2.Q.EVE:Date)
  BRW2.AddField(EVE:Number,BRW2.Q.EVE:Number)
  BRW2.AddField(EVE:Sponsor,BRW2.Q.EVE:Sponsor)
  BRW7.Q &= Queue:Browse
  BRW7.AddSortOrder(,SPH:KeySponsorNumber)
  BRW7.AddRange(SPH:SponsorNumber,Relate:SPhones,Relate:Sponsor)
  BRW7.AddLocator(BRW7::Sort0:Locator)
  BRW7::Sort0:Locator.Init(,SPH:SponsorNumber,1,BRW7)
  BRW7.AddField(SPH:Description,BRW7.Q.SPH:Description)
  BRW7.AddField(SPH:PhoneNumber,BRW7.Q.SPH:PhoneNumber)
  BRW7.AddField(SPH:SponsorNumber,BRW7.Q.SPH:SponsorNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('UpdateSponsor',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW2.AskProcedure = 2
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  BRW7.AddToolbarTarget(Toolbar)
  BRW7.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Events.Close
    Relate:States.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateSponsor',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.PrimeFields PROCEDURE

  CODE
    SPO:City = DefaultCity
    SPO:State = DefaultState
    SPO:Zip = DefaultZIP
  PARENT.PrimeFields


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      BrowseStates
      UpdateEvents
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SPO:State
      IF SPO:State OR ?SPO:State{Prop:Req}
        ST:StateCode = SPO:State
        IF Access:States.TryFetch(ST:StateKey)
          IF SELF.Run(1,SelectRecord) = RequestCompleted
            SPO:State = ST:StateCode
          ELSE
            SELECT(?SPO:State)
            CYCLE
          END
        END
      END
      ThisWindow.Reset(0)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    Quickwindow{Prop:Text}= ACTIONMESSAGE & '--' & SPO:CompanyName
  
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


BRW7.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW7::EIPManager
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

Eventmgr_BrowseSponsors PROCEDURE                     !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LOC:Running:BrowseSponsors LONG(0)
LOC:FullAddress      STRING(200)
BRW1::View:Browse    VIEW(Sponsor)
                       PROJECT(SPO:CompanyName)
                       PROJECT(SPO:Address)
                       PROJECT(SPO:Address2)
                       PROJECT(SPO:City)
                       PROJECT(SPO:State)
                       PROJECT(SPO:Zip)
                       PROJECT(SPO:SponsorNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
SPO:CompanyName        LIKE(SPO:CompanyName)          !List box control field - type derived from field
SPO:Address            LIKE(SPO:Address)              !Browse hot field - type derived from field
SPO:Address2           LIKE(SPO:Address2)             !Browse hot field - type derived from field
SPO:City               LIKE(SPO:City)                 !Browse hot field - type derived from field
SPO:State              LIKE(SPO:State)                !Browse hot field - type derived from field
SPO:Zip                LIKE(SPO:Zip)                  !Browse hot field - type derived from field
LOC:FullAddress        LIKE(LOC:FullAddress)          !Browse hot field - type derived from local data
SPO:SponsorNumber      LIKE(SPO:SponsorNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW6::View:Browse    VIEW(SPhones)
                       PROJECT(SPH:Description)
                       PROJECT(SPH:PhoneNumber)
                       PROJECT(SPH:SponsorNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
SPH:Description        LIKE(SPH:Description)          !List box control field - type derived from field
SPH:PhoneNumber        LIKE(SPH:PhoneNumber)          !List box control field - type derived from field
SPH:SponsorNumber      LIKE(SPH:SponsorNumber)        !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Sponsors'),AT(,,266,187),FONT('MS Sans Serif',8,,),ICON('HNDSHAKE.ICO'),HLP('~BrowseSponsors'),SYSTEM,GRAY,RESIZE,MDI,IMM
                       LIST,AT(8,20,88,140),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('80L(2)|M~Company Name~S(25)@S25@'),FROM(Queue:Browse:1)
                       BUTTON('&Insert'),AT(17,107,18,14),USE(?Insert:2),HIDE
                       BUTTON('&Change'),AT(39,108,18,14),USE(?Change:2),HIDE,DEFAULT
                       BUTTON('&Delete'),AT(64,106,18,14),USE(?Delete:2),HIDE
                       SHEET,AT(4,4,258,162),USE(?CurrentTab)
                         TAB('By Company Name')
                           PANEL,AT(105,21,152,140),USE(?Panel1),BEVEL(-1,-1)
                           TEXT,AT(116,30,132,47),USE(LOC:FullAddress),SKIP,COLOR(COLOR:BTNFACE),READONLY
                           LIST,AT(116,87,132,64),USE(?List),IMM,VSCROLL,COLOR(COLOR:BTNFACE),MSG('Browsing Records'),FORMAT('40L|M@s10@80L|M@s20@'),FROM(Queue:Browse)
                         END
                       END
                       BUTTON('Close'),AT(151,170,45,14),USE(?Close)
                       BUTTON('Help'),AT(201,170,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
BRW6                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
                     END

BRW6::Sort0:Locator  StepLocatorClass                 !Default Locator
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_BrowseSponsors')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  ALERT(F3Key,F6Key)
  !!Limit to only one instance
   IF GlobalRequest<>SelectRecord
    IF NOT GLO:Running:BrowseSponsors     !If its not running
      GLO:Running:BrowseSponsors=THREAD()  !Set global var to indicate this instance is running
      LOC:Running:BrowseSponsors=THREAD()  !Set Local var to indicate this instance is running
    ELSE                                 !If it is running
      POST(Event:GainFocus,,GLO:Running:BrowseSponsors) !bring to front
      RETURN Level:Fatal  !don't continute this with this instance
    END
   END
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:SPhones.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Sponsor,SELF)
  BRW6.Init(?List,Queue:Browse.ViewPosition,BRW6::View:Browse,Queue:Browse,Relate:SPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,SPO:KeyCompanyName)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,SPO:CompanyName,1,BRW1)
  BIND('LOC:FullAddress',LOC:FullAddress)
  BRW1.AddField(SPO:CompanyName,BRW1.Q.SPO:CompanyName)
  BRW1.AddField(SPO:Address,BRW1.Q.SPO:Address)
  BRW1.AddField(SPO:Address2,BRW1.Q.SPO:Address2)
  BRW1.AddField(SPO:City,BRW1.Q.SPO:City)
  BRW1.AddField(SPO:State,BRW1.Q.SPO:State)
  BRW1.AddField(SPO:Zip,BRW1.Q.SPO:Zip)
  BRW1.AddField(LOC:FullAddress,BRW1.Q.LOC:FullAddress)
  BRW1.AddField(SPO:SponsorNumber,BRW1.Q.SPO:SponsorNumber)
  BRW6.Q &= Queue:Browse
  BRW6.AddSortOrder(,SPH:KeySponsorNumber)
  BRW6.AddRange(SPH:SponsorNumber,Relate:SPhones,Relate:Sponsor)
  BRW6.AddLocator(BRW6::Sort0:Locator)
  BRW6::Sort0:Locator.Init(,SPH:SponsorNumber,1,BRW6)
  BRW6.AddField(SPH:Description,BRW6.Q.SPH:Description)
  BRW6.AddField(SPH:PhoneNumber,BRW6.Q.SPH:PhoneNumber)
  BRW6.AddField(SPH:SponsorNumber,BRW6.Q.SPH:SponsorNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Eventmgr_BrowseSponsors',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  BRW6.AddToolbarTarget(Toolbar)
  BRW6.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:SPhones.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_BrowseSponsors',QuickWindow)
  END
  !!Reset Thread Limiting flag
  IF LOC:Running:BrowseSponsors
     GLO:Running:BrowseSponsors=0
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    UpdateSponsor
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:AlertKey
      !Handle All Procedure HotKeys
      CASE KEYCODE()
        OF F3Key
            POST(EVENT:Accepted,GLO:MemberButton,GLO:AppFrameThread)
        OF F4Key
            POST(EVENT:Accepted,GLO:VendorButton,GLO:AppFrameThread)
        OF F5Key
            POST(EVENT:Accepted,GLO:EventButton,GLO:AppFrameThread)
        OF F6Key
            POST(EVENT:Accepted,GLO:SponsorButton,GLO:AppFrameThread)
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:GainFocus
      !!Bring to front and restore to normal size if iconized
      quickwindow{PROP:Active}=TRUE
      IF quickwindow{PROP:Iconize}=TRUE
        quickwindow{PROP:Iconize}=''
      END
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.SetQueueRecord PROCEDURE

  CODE
  IF (SPO:Address2)
    LOC:FullAddress = SPO:Address & '<13,10>' & SPO:Address2 & '<13,10>' & CLIP(SPO:City) & ', ' & SPO:State & ' ' & SPO:Zip
  ELSE
    LOC:FullAddress = SPO:Address & '<13,10>' & CLIP(SPO:City) & ', ' & SPO:State & ' ' & SPO:Zip
  END
  PARENT.SetQueueRecord
  SELF.Q.LOC:FullAddress = LOC:FullAddress            !Assign formula result to display queue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

Eventmgr_Preferences PROCEDURE (CalledAtStartUp)      !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
FDB1::View:FileDrop  VIEW(States)
                       PROJECT(ST:StateCode)
                       PROJECT(ST:StateName)
                     END
Queue:FileDrop       QUEUE                            !Queue declaration for browse/combo box using ?DefaultState
ST:StateCode           LIKE(ST:StateCode)             !List box control field - type derived from field
ST:StateName           LIKE(ST:StateName)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
window               WINDOW('Preferences'),AT(,,169,146),FONT('MS Sans Serif',8,,FONT:regular),HLP('~UserPreferences'),STATUS,GRAY,RESIZE
                       CHECK('Enable &Sound'),AT(13,2),USE(DefaultSoundEnable)
                       GROUP('&Address Defaults'),AT(13,16,143,53),USE(?Group1),BOXED
                         ENTRY(@s20),AT(63,25,87,10),USE(DefaultCity),TIP('Default City for new Addresses')
                         PROMPT('Default &City:'),AT(23,26),USE(?DefaultCity:Prompt)
                         PROMPT('Default &State:'),AT(17,40),USE(?Prompt2)
                         LIST,AT(63,40,87,10),USE(DefaultState),TIP('Default State  for new Addresses'),FORMAT('23L~Code~L(2)@s2@80L~State Name~@s20@'),DROP(5),FROM(Queue:FileDrop)
                         PROMPT('Default &ZIP:'),AT(23,55),USE(?DefaultZIP:Prompt)
                         ENTRY(@s10),AT(63,55,87,10),USE(DefaultZIP),TIP('Default ZIP Code for new Addresses')
                       END
                       GROUP('&Event Defaults'),AT(13,73,128,39),USE(?Group2),BOXED
                         SPIN(@n3),AT(99,81,27,10),USE(DefaultMaxTables),TIP('Default Number of Tables for an Event'),RANGE(1,20),STEP(1)
                         PROMPT('Default Max Tables:'),AT(29,81),USE(?DefaultMaxTables:Prompt)
                         SPIN(@n3),AT(99,97,27,10),USE(DefaultSeatsPerTable),TIP('Default Number of Seats at Tables for an Event'),RANGE(1,20),STEP(1)
                         PROMPT('Default Seats Per Table:'),AT(17,97),USE(?DefaultSeatsPerTable:Prompt)
                       END
                       BUTTON('OK'),AT(13,128,34,14),USE(?OK)
                       BUTTON('Cancel'),AT(63,128),USE(?Cancel)
                       BUTTON('Help'),AT(126,128,34,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
FDB1                 CLASS(FileDropClass)             !File drop manager
Q                      &Queue:FileDrop                !Reference to display queue
                     END


  CODE
  GlobalResponse = ThisWindow.Run()

GetFromINI ROUTINE
 DefaultSoundEnable=GETINI('Preferences','SoundEnable',1,'EVENTMGR.INI')
 DefaultCity=GETINI('Preferences','City',,'EVENTMGR.INI')
 DefaultState=GETINI('Preferences','State',,'EVENTMGR.INI')
 DefaultZIP=GETINI('Preferences','ZIP',,'EVENTMGR.INI')
 DefaultMaxTables=GETINI('Preferences','Defaultmaxtables',20,'EVENTMGR.INI')
 DefaultSeatsPerTable=GETINI('Preferences','DefaultSeatsPerTable',20,'EVENTMGR.INI')
SaveToINI ROUTINE
 PUTINI('Preferences','City',DefaultCity,'EVENTMGR.INI')
 PUTINI('Preferences','State',DefaultState,'EVENTMGR.INI')
 PUTINI('Preferences','ZIP',DefaultZIP,'EVENTMGR.INI')
 PUTINI('Preferences','SoundEnable',DefaultSoundEnable,'EVENTMGR.INI')
 PUTINI('Preferences','Defaultmaxtables',Defaultmaxtables,'EVENTMGR.INI')
 PUTINI('Preferences','DefaultSeatsPerTable',DefaultSeatsPerTable,'EVENTMGR.INI')

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_Preferences')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?DefaultSoundEnable
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  DO GetFromINI
  IF CalledAtStartUp
    RETURN Level:Fatal
  END
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?OK,RequestCancelled)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:States.Open
  SELF.FilesOpened = True
  OPEN(window)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_Preferences',window)
  FDB1.Init(?DefaultState,Queue:FileDrop.ViewPosition,FDB1::View:FileDrop,Queue:FileDrop,Relate:States,ThisWindow)
  FDB1.Q &= Queue:FileDrop
  FDB1.AddSortOrder()
  FDB1.AddField(ST:StateCode,FDB1.Q.ST:StateCode)
  FDB1.AddField(ST:StateName,FDB1.Q.ST:StateName)
  FDB1.AddUpdateField(ST:StateCode,DefaultState)
  ThisWindow.AddItem(FDB1.WindowComponent)
  FDB1.DefaultFill = 0
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:States.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_Preferences',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      DO SaveToINI
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

